SDL_atomic.c File Reference
`#include "../SDL_internal.h"`
`#include "SDL_atomic.h"`
Include dependency graph for SDL_atomic.c:

Go to the source code of this file.

## Macros

#define | EMULATE_CAS 1

## Functions

static SDL_INLINE void | enterLock (void *a)
static SDL_INLINE void | leaveLock (void *a)
SDL_bool | SDL_AtomicCAS (SDL_atomic_t *a, int oldval, int newval)
| Set an atomic variable to a new value if it is currently an old value. More...
SDL_bool | SDL_AtomicCASPtr (void **a, void *oldval, void *newval)
| Set a pointer to a new value if it is currently an old value. More...
int | SDL_AtomicSet (SDL_atomic_t *a, int v)
| Set an atomic variable to a value. More...
void * | SDL_AtomicSetPtr (void **a, void *v)
| Set a pointer to a value atomically. More...
int | SDL_AtomicAdd (SDL_atomic_t *a, int v)
| Add to an atomic variable. More...
int | SDL_AtomicGet (SDL_atomic_t *a)
| Get the value of an atomic variable. More...
void * | SDL_AtomicGetPtr (void **a)
| Get the value of a pointer atomically. More...
void | SDL_MemoryBarrierReleaseFunction (void)
void | SDL_MemoryBarrierAcquireFunction (void)

## Variables

static SDL_SpinLock | locks [32]

## Macro Definition Documentation

## EMULATE_CAS

#define EMULATE_CAS 1

Definition at line 104 of file SDL_atomic.c.

## Function Documentation

## enterLock()

static SDL_INLINE void enterLock | ( | void * | a | ) |

static

Definition at line 111 of file SDL_atomic.c.

References locks, SDL_AtomicLock, and SDL_INLINE.

Referenced by SDL_AtomicCAS(), and SDL_AtomicCASPtr().

{
uintptr_t index = ((((uintptr_t)a) >> 3) & 0x1f);
SDL_AtomicLock(&locks[index]);
}
SDL_AtomicLock
#define SDL_AtomicLock
Definition: SDL_dynapi_overrides.h:64
uintptr_t
unsigned int uintptr_t
Definition: SDL_config_windows.h:70
index
GLuint index
Definition: SDL_opengl_glext.h:660
locks
static SDL_SpinLock locks[32]
Definition: SDL_atomic.c:108
a
GLboolean GLboolean GLboolean GLboolean a
Definition: SDL_opengl_glext.h:1109

## leaveLock()

static SDL_INLINE void leaveLock | ( | void * | a | ) |

static

Definition at line 119 of file SDL_atomic.c.

References locks, and SDL_AtomicUnlock.

Referenced by SDL_AtomicCAS(), and SDL_AtomicCASPtr().

{
uintptr_t index = ((((uintptr_t)a) >> 3) & 0x1f);
SDL_AtomicUnlock(&locks[index]);
}
SDL_AtomicUnlock
#define SDL_AtomicUnlock
Definition: SDL_dynapi_overrides.h:65
uintptr_t
unsigned int uintptr_t
Definition: SDL_config_windows.h:70
index
GLuint index
Definition: SDL_opengl_glext.h:660
locks
static SDL_SpinLock locks[32]
Definition: SDL_atomic.c:108
a
GLboolean GLboolean GLboolean GLboolean a
Definition: SDL_opengl_glext.h:1109

## SDL_AtomicAdd()

int SDL_AtomicAdd | ( | SDL_atomic_t * | a,
|  | int | v
| ) |  |

Add to an atomic variable.

Returns
  The previous value of the atomic variable.

Note
  This same style can be used for any number operation

Definition at line 237 of file SDL_atomic.c.

References SDL_AtomicCAS(), and SDL_atomic_t::value.

{
#ifdef HAVE_MSC_ATOMICS
return _InterlockedExchangeAdd((long*)&a->value, v);
#elif defined(HAVE_WATCOM_ATOMICS)
return _SDL_xadd_watcom(&a->value, v);
#elif defined(HAVE_GCC_ATOMICS)
return __sync_fetch_and_add(&a->value, v);
#elif defined(__SOLARIS__)
int pv = a->value;
membar_consumer();
#if defined(_LP64)
atomic_add_64((volatile uint64_t*)&a->value, v);
#elif !defined(_LP64)
atomic_add_32((volatile uint32_t*)&a->value, v);
#endif
return pv;
#else
int value;
do {
value = a->value;
} while (!SDL_AtomicCAS(a, value, (value + v)));
return value;
#endif
}
v
const GLdouble * v
Definition: SDL_opengl.h:2064
uint64_t
unsigned long long uint64_t
Definition: SDL_config_windows.h:65
value
GLsizei const GLfloat * value
Definition: SDL_opengl_glext.h:698
SDL_atomic_t::value
int value
Definition: SDL_atomic.h:198
uint32_t
unsigned int uint32_t
Definition: SDL_config_windows.h:63
SDL_AtomicCAS
SDL_bool SDL_AtomicCAS(SDL_atomic_t *a, int oldval, int newval)
Set an atomic variable to a new value if it is currently an old value.
Definition: SDL_atomic.c:129

## SDL_AtomicCAS()

SDL_bool SDL_AtomicCAS | ( | SDL_atomic_t * | a,
|  | int | oldval,
|  | int | newval
| ) |  |

Set an atomic variable to a new value if it is currently an old value.

Returns
  SDL_TRUE if the atomic variable was set, SDL_FALSE otherwise.

Note
  If you don't know what this function is for, you shouldn't use it!

Definition at line 129 of file SDL_atomic.c.

References enterLock(), leaveLock(), retval, SDL_FALSE, SDL_TRUE, and SDL_atomic_t::value.

Referenced by SDL_AtomicAdd(), SDL_AtomicGet(), and SDL_AtomicSet().

{
#ifdef HAVE_MSC_ATOMICS
return (_InterlockedCompareExchange((long*)&a->value, (long)newval, (long)oldval) == (long)oldval);
#elif defined(HAVE_WATCOM_ATOMICS)
return (SDL_bool) _SDL_cmpxchg_watcom(&a->value, newval, oldval);
#elif defined(HAVE_GCC_ATOMICS)
return (SDL_bool) __sync_bool_compare_and_swap(&a->value, oldval, newval);
#elif defined(__MACOSX__) /* this is deprecated in 10.12 sdk; favor gcc atomics. */
return (SDL_bool) OSAtomicCompareAndSwap32Barrier(oldval, newval, &a->value);
#elif defined(__SOLARIS__) && defined(_LP64)
return (SDL_bool) ((int) atomic_cas_64((volatile uint64_t*)&a->value, (uint64_t)oldval, (uint64_t)newval) == oldval);
#elif defined(__SOLARIS__) && !defined(_LP64)
return (SDL_bool) ((int) atomic_cas_32((volatile uint32_t*)&a->value, (uint32_t)oldval, (uint32_t)newval) == oldval);
#elif EMULATE_CAS
SDL_bool retval = SDL_FALSE;
enterLock(a);
if (a->value == oldval) {
a->value = newval;
retval = SDL_TRUE;
}
leaveLock(a);
return retval;
#else
#error Please define your platform.
#endif
}
SDL_TRUE
Definition: SDL_stdinc.h:142
SDL_FALSE
Definition: SDL_stdinc.h:141
uint64_t
unsigned long long uint64_t
Definition: SDL_config_windows.h:65
retval
SDL_bool retval
Definition: testgamecontroller.c:65
leaveLock
static SDL_INLINE void leaveLock(void *a)
Definition: SDL_atomic.c:119
enterLock
static SDL_INLINE void enterLock(void *a)
Definition: SDL_atomic.c:111
SDL_atomic_t::value
int value
Definition: SDL_atomic.h:198
SDL_bool
SDL_bool
Definition: SDL_stdinc.h:139
uint32_t
unsigned int uint32_t
Definition: SDL_config_windows.h:63

## SDL_AtomicCASPtr()

SDL_bool SDL_AtomicCASPtr | ( | void ** | a,
|  | void * | oldval,
|  | void * | newval
| ) |  |

Set a pointer to a new value if it is currently an old value.

Returns
  SDL_TRUE if the pointer was set, SDL_FALSE otherwise.

Note
  If you don't know what this function is for, you shouldn't use it!

Definition at line 160 of file SDL_atomic.c.

References enterLock(), leaveLock(), retval, SDL_FALSE, and SDL_TRUE.

Referenced by SDL_AtomicGetPtr(), and SDL_AtomicSetPtr().

{
#if defined(HAVE_MSC_ATOMICS) && (_M_IX86)
return (_InterlockedCompareExchange((long*)a, (long)newval, (long)oldval) == (long)oldval);
#elif defined(HAVE_MSC_ATOMICS) && (!_M_IX86)
return (_InterlockedCompareExchangePointer(a, newval, oldval) == oldval);
#elif defined(HAVE_WATCOM_ATOMICS)
return (SDL_bool) _SDL_cmpxchg_watcom((int *)a, (long)newval, (long)oldval);
#elif defined(HAVE_GCC_ATOMICS)
return __sync_bool_compare_and_swap(a, oldval, newval);
#elif defined(__MACOSX__) && defined(__LP64__) /* this is deprecated in 10.12 sdk; favor gcc atomics. */
return (SDL_bool) OSAtomicCompareAndSwap64Barrier((int64_t)oldval, (int64_t)newval, (int64_t*) a);
#elif defined(__MACOSX__) && !defined(__LP64__) /* this is deprecated in 10.12 sdk; favor gcc atomics. */
return (SDL_bool) OSAtomicCompareAndSwap32Barrier((int32_t)oldval, (int32_t)newval, (int32_t*) a);
#elif defined(__SOLARIS__)
return (SDL_bool) (atomic_cas_ptr(a, oldval, newval) == oldval);
#elif EMULATE_CAS
SDL_bool retval = SDL_FALSE;
enterLock(a);
if (*a == oldval) {
*a = newval;
retval = SDL_TRUE;
}
leaveLock(a);
return retval;
#else
#error Please define your platform.
#endif
}
SDL_TRUE
Definition: SDL_stdinc.h:142
int32_t
signed int int32_t
Definition: SDL_config_windows.h:62
SDL_FALSE
Definition: SDL_stdinc.h:141
retval
SDL_bool retval
Definition: testgamecontroller.c:65
leaveLock
static SDL_INLINE void leaveLock(void *a)
Definition: SDL_atomic.c:119
enterLock
static SDL_INLINE void enterLock(void *a)
Definition: SDL_atomic.c:111
SDL_bool
SDL_bool
Definition: SDL_stdinc.h:139
a
GLboolean GLboolean GLboolean GLboolean a
Definition: SDL_opengl_glext.h:1109
int64_t
signed long long int64_t
Definition: SDL_config_windows.h:64

## SDL_AtomicGet()

int SDL_AtomicGet | ( | SDL_atomic_t * | a | ) |

Get the value of an atomic variable.

Definition at line 264 of file SDL_atomic.c.

References SDL_AtomicCAS(), and SDL_atomic_t::value.

{
#ifdef HAVE_ATOMIC_LOAD_N
return __atomic_load_n(&a->value, __ATOMIC_SEQ_CST);
#else
int value;
do {
value = a->value;
} while (!SDL_AtomicCAS(a, value, value));
return value;
#endif
}
value
GLsizei const GLfloat * value
Definition: SDL_opengl_glext.h:698
SDL_atomic_t::value
int value
Definition: SDL_atomic.h:198
SDL_AtomicCAS
SDL_bool SDL_AtomicCAS(SDL_atomic_t *a, int oldval, int newval)
Set an atomic variable to a new value if it is currently an old value.
Definition: SDL_atomic.c:129

## SDL_AtomicGetPtr()

void* SDL_AtomicGetPtr | ( | void ** | a | ) |

Get the value of a pointer atomically.

Definition at line 278 of file SDL_atomic.c.

References SDL_AtomicCASPtr().

{
#ifdef HAVE_ATOMIC_LOAD_N
return __atomic_load_n(a, __ATOMIC_SEQ_CST);
#else
void *value;
do {
value = *a;
} while (!SDL_AtomicCASPtr(a, value, value));
return value;
#endif
}
SDL_AtomicCASPtr
SDL_bool SDL_AtomicCASPtr(void **a, void *oldval, void *newval)
Set a pointer to a new value if it is currently an old value.
Definition: SDL_atomic.c:160
value
GLsizei const GLfloat * value
Definition: SDL_opengl_glext.h:698
a
GLboolean GLboolean GLboolean GLboolean a
Definition: SDL_opengl_glext.h:1109

## SDL_AtomicSet()

int SDL_AtomicSet | ( | SDL_atomic_t * | a,
|  | int | v
| ) |  |

Set an atomic variable to a value.

Returns
  The previous value of the atomic variable.

Definition at line 193 of file SDL_atomic.c.

References SDL_AtomicCAS(), and SDL_atomic_t::value.

{
#ifdef HAVE_MSC_ATOMICS
return _InterlockedExchange((long*)&a->value, v);
#elif defined(HAVE_WATCOM_ATOMICS)
return _SDL_xchg_watcom(&a->value, v);
#elif defined(HAVE_GCC_ATOMICS)
return __sync_lock_test_and_set(&a->value, v);
#elif defined(__SOLARIS__) && defined(_LP64)
return (int) atomic_swap_64((volatile uint64_t*)&a->value, (uint64_t)v);
#elif defined(__SOLARIS__) && !defined(_LP64)
return (int) atomic_swap_32((volatile uint32_t*)&a->value, (uint32_t)v);
#else
int value;
do {
value = a->value;
} while (!SDL_AtomicCAS(a, value, v));
return value;
#endif
}
v
const GLdouble * v
Definition: SDL_opengl.h:2064
uint64_t
unsigned long long uint64_t
Definition: SDL_config_windows.h:65
value
GLsizei const GLfloat * value
Definition: SDL_opengl_glext.h:698
SDL_atomic_t::value
int value
Definition: SDL_atomic.h:198
uint32_t
unsigned int uint32_t
Definition: SDL_config_windows.h:63
SDL_AtomicCAS
SDL_bool SDL_AtomicCAS(SDL_atomic_t *a, int oldval, int newval)
Set an atomic variable to a new value if it is currently an old value.
Definition: SDL_atomic.c:129

## SDL_AtomicSetPtr()

void* SDL_AtomicSetPtr | ( | void ** | a,
|  | void * | v
| ) |  |

Set a pointer to a value atomically.

Returns
  The previous value of the pointer.

Definition at line 215 of file SDL_atomic.c.

References SDL_AtomicCASPtr().

{
#if defined(HAVE_MSC_ATOMICS) && (_M_IX86)
return (void *) _InterlockedExchange((long *)a, (long) v);
#elif defined(HAVE_MSC_ATOMICS) && (!_M_IX86)
return _InterlockedExchangePointer(a, v);
#elif defined(HAVE_WATCOM_ATOMICS)
return (void *) _SDL_xchg_watcom((int *)a, (long)v);
#elif defined(HAVE_GCC_ATOMICS)
return __sync_lock_test_and_set(a, v);
#elif defined(__SOLARIS__)
return atomic_swap_ptr(a, v);
#else
void *value;
do {
value = *a;
} while (!SDL_AtomicCASPtr(a, value, v));
return value;
#endif
}
v
const GLdouble * v
Definition: SDL_opengl.h:2064
SDL_AtomicCASPtr
SDL_bool SDL_AtomicCASPtr(void **a, void *oldval, void *newval)
Set a pointer to a new value if it is currently an old value.
Definition: SDL_atomic.c:160
value
GLsizei const GLfloat * value
Definition: SDL_opengl_glext.h:698
a
GLboolean GLboolean GLboolean GLboolean a
Definition: SDL_opengl_glext.h:1109

## SDL_MemoryBarrierAcquireFunction()

void SDL_MemoryBarrierAcquireFunction | ( | void |  | ) |

Definition at line 298 of file SDL_atomic.c.

References SDL_MemoryBarrierAcquire.

{
SDL_MemoryBarrierAcquire();
}
SDL_MemoryBarrierAcquire
#define SDL_MemoryBarrierAcquire()
Definition: SDL_atomic.h:190

## SDL_MemoryBarrierReleaseFunction()

void SDL_MemoryBarrierReleaseFunction | ( | void |  | ) |

Memory barriers are designed to prevent reads and writes from being reordered by the compiler and being seen out of order on multi-core CPUs.

A typical pattern would be for thread A to write some data and a flag, and for thread B to read the flag and get the data. In this case you would insert a release barrier between writing the data and the flag, guaranteeing that the data write completes no later than the flag is written, and you would insert an acquire barrier between reading the flag and reading the data, to ensure that all the reads associated with the flag have completed.

In this pattern you should always see a release barrier paired with an acquire barrier and you should gate the data reads/writes with a single flag variable.

For more information on these semantics, take a look at the blog post: http://preshing.com/20120913/acquire-and-release-semantics

Definition at line 292 of file SDL_atomic.c.

References SDL_MemoryBarrierRelease.

{
SDL_MemoryBarrierRelease();
}
SDL_MemoryBarrierRelease
#define SDL_MemoryBarrierRelease()
Definition: SDL_atomic.h:189

## Variable Documentation

## locks

SDL_SpinLock locks[32]

static

Definition at line 108 of file SDL_atomic.c.

Referenced by enterLock(), and leaveLock().